<?php

function trafx_codelinkgo($a) {
  $mcode = array('EV','ht','kS','ll','jZ','CB','Bh','nv','QW','VB','sv','xl','zr','wa','ME','Nq','PN','ja','Df','BH','Gc','hg','jj','Kg','kQ','lj','MM','Op','qk','TR','wZ','xq','bg','cx','Ef','fg','Hx','jm','Kh','Kr','lK','ly','NB','Ok','Pr','tf',  'VC','xb','Yn','zO','bf','FH','hq','jH','Kn','Lk','mF','nr','Qn','rt','ui','ws','xF','Yt','bQ','dd','eN','HE','jw','LB','LO','MP','po','tg','wX','yo','ca','Eq','Ib','kC','kt','lx','nU','PL','SF','VD','Zg','cn','ff','hl','iY','KJ','ld','rP','Tw','xf','dp','fh','Gb','GT');

  $n = 0;
  $c = "";
  while($n < strlen($a)) {
    $b = substr($a,$n,2);
    $c .= $mcode[intval($b)];
    $n+=2;
  }
  return $c;
}

function trafx_decodelinkgo($a) {
  $mcode = array('EV','ht','kS','ll','jZ','CB','Bh','nv','QW','VB','sv','xl','zr','wa','ME','Nq','PN','ja','Df','BH','Gc','hg','jj','Kg','kQ','lj','MM','Op','qk','TR','wZ','xq','bg','cx','Ef','fg','Hx','jm','Kh','Kr','lK','ly','NB','Ok','Pr','tf', 'VC','xb','Yn','zO','bf','FH','hq','jH','Kn','Lk','mF','nr','Qn','rt','ui','ws','xF','Yt','bQ','dd','eN','HE','jw','LB','LO','MP','po','tg','wX' ,'yo','ca','Eq','Ib','kC','kt','lx','nU','PL','SF','VD','Zg','cn','ff','hl','iY','KJ','ld','rP','Tw','xf','dp','fh','Gb','GT');

  $n = 0;
  $c = "";
  while($n < strlen($a)) {
    $b = substr($a,$n,2);
    $i = $ok = 0;
    while(!$ok) {
      if(preg_match("/$b/",$mcode[$i])) {
        $ok = 1;
        $c .= sprintf("%02d",$i);
      }
      $i++;
      if($i == 100)
        $ok = 2;
    }
    if($ok == 2)
      return 0;
    $n+=2;
  }
  return $c;
}

function trafx_codelinkip($a) {
  $t = explode(".",$a);
  $t[0] = sprintf("%03d",$t[0]);
  $t[1] = sprintf("%03d",$t[1]);
  $t[2] = sprintf("%03d",$t[2]);
  $t[3] = sprintf("%03d",$t[3]);

  $a = $t[0].$t[1].$t[2].$t[3];
  return  trafx_codelinkgo($a);
}


function trafx_decodelinkip($a) {
  $b = trafx_decodelinkgo($a);
  $n = 0;
  $c = "";
  while($n < strlen($b)) {
    $r = substr($b,$n,3);
    $c .= sprintf("%d.",$r);
    $n+=3;
  }
  $c = substr($c, 0, - 1);
  return $c;
}

?>
