<?php

//
// Add entry to the market
//

function trafx_admin_mkadd() {

  $mlang = $_POST['lang'];
  $mgenre = $_POST['genre'];
  $msite = $_SERVER["HTTP_HOST"];

  $murl = preg_replace("/;/","",$_POST['url']);
  $murl = preg_replace("/\|/","",$murl);
  $murl = preg_replace("/'/","",$murl);
  $murl = preg_replace("/\n/","",$murl);

  $mnom = preg_replace("/;/","",$_POST['nom']);
  $mnom = preg_replace("/\|/","",$mnom);
  $mnom = preg_replace("/'/","",$mnom);
  $mnom = preg_replace("/\n/","",$mnom);


  $mc = "01;".$murl."|".$msite."|".$mnom."|".$mlang."|".$mgenre;
  $min = "cargo=".urlencode($mc);
  $mrep = trafx_send_socket("trafx-mk.php?op=cargo",$min,TRAFX_TXT92,TRAFX_TXT93);

  if(!empty($mrep)) {
    $a = TRAFX_TXT5;
    if(get_option('trafx_market'))
      delete_option('trafx_market');
    add_option('trafx_market',$mrep,'','yes');
  }
  else
    $a = TRAFX_TXT6;

  trafx_admin_menu($a);

}

//
// Remove entry from the market
//

function trafx_admin_mkrem($mid) {
  $mc = "02;".$mid;
  $min = "cargo=".urlencode($mc);
  $mrep = trafx_send_socket("trafx-mk.php?op=cargo",$min,TRAFX_TXT92,TRAFX_TXT93);
  if(!empty($mrep)) {
    $a = TRAFX_TXT7;
    delete_option('trafx_market');
  }
  else
    $a = TRAFX_TXT6;
  trafx_admin_menu($a);
}

//
// The Market
//

function trafx_admin_market() {
  global $wpdb;

  $a = "";
  $a .=  "<h3>".TRAFX_TXT8."</h3>";
  $a .= '<table style="border: #cccccc 1px outset;" border="1" cellspacing="1" cellpadding="3" width="50%">';
  $a .= "<tr><td><b>".TRAFX_TXT89."</b></td><td><b>".TRAFX_TXT90."</b></td><td><b>".TRAFX_TXT79."</b></td><td><b>".TRAFX_TXT78."</b></td></tr>\n";
  $sql =  $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "trafx_market ORDER BY id DESC");
  foreach ($sql as $res) {
        $a .= "<tr>";
        $a .= '<td><a href="http://'.$res->site.'" target="_blank">'.$res->nom."</a></td>";
        $a .= '<td><a href="'.$res->url.'" target="_blank">'.TRAFX_TXT9.'</a></td>';
        $a .= "<td>".trafx_admin_genre($res->genre)."</td>";
        $a .= "<td>".trafx_admin_lang($res->lang)."</td>";
        $a ."</tr>\n";
  }
  $a .= "</table>\n";
  echo $a;
}

//
// Display market
//
function trafx_admin_display_market() {
  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
  $mrequrl = preg_replace("/\&id=(.*)+/","",$mrequrl);

  $mnom = preg_replace("/http:\/\//","",get_option('siteurl'));

  $a = "";
  $a .= '<h3><a href="'.$mrequrl.'&op=market">'.TRAFX_TXT72.'</a></h3>'."\n";

  $mg = get_option("trafx_market");
  if(strlen($mg)) {
    $a .= TRAFX_TXT73.' <a href="'.$mrequrl.'&op=mkrem&id='.$mg.'">'.TRAFX_TXT74.'</a>'."\n";
  }
  else {
    $a .= TRAFX_TXT75."<br />\n";
    $a .= "<table>\n";
    $a .= '<form action="'.$mrequrl.'&op=mkadd" method="post">'."\n";
    $a .= "<tr><td>".TRAFX_TXT76.': </td><td><input type="text" size=30 name="nom" value="'.$mnom.'"></td></tr>'."\n";
    $a .= "<tr><td>".TRAFX_TXT77.': </td><td><input type="text" size=50 name="url" value="http://"></td></tr>'."\n";
    $a .= "<tr><td>".TRAFX_TXT78.": </td>";
    $a .= '<td><select name="lang">';
    $a .= '<option value="1">'.TRAFX_TXT25.'</option>';
    $a .= '<option selected value="2">'.TRAFX_TXT26.'</option>';
    $a .= '<option value="3">'.TRAFX_TXT27.'</option>';
    $a .= '<option value="4">'.TRAFX_TXT28.'</option>';
    $a .= '<option value="5">'.TRAFX_TXT29.'</option>';
    $a .= "</select></td>";
    $a .= "</tr>\n";
    $a .= "<tr><td>".TRAFX_TXT79.": </td>";
    $a .= '<td><select name="genre">';
    $a .= '<option value="1">'.TRAFX_TXT30.'</option>';
    $a .= '<option selected value="2">'.TRAFX_TXT31.'</option>';
    $a .= '<option value="3">'.TRAFX_TXT32.'</option>';
    $a .= '<option value="4">'.TRAFX_TXT33.'</option>';
    $a .= '<option value="5">'.TRAFX_TXT34.'</option>';
    $a .= '<option value="6">'.TRAFX_TXT35.'</option>';
    $a .= '<option value="7">'.TRAFX_TXT29.'</option>';
    $a .= "</select></td>";
    $a .= "</tr>\n";

    $a .= '<tr><td colspan=2><input type="submit" value="'.TRAFX_TXT54.'"></td></tr></form>'."\n";
    $a .= "</table>";
  }
  return $a;
}

function trafx_admin_lang($ml) {
  switch($ml) {
    case "1":
      $mlang = TRAFX_TXT25;
      break;
    case "2":
      $mlang = TRAFX_TXT26;
      break;
    case "3":
      $mlang = TRAFX_TXT27;
      break;
    case "4":
      $mlang = TRAFX_TXT28;
      break;
    default:
      $mlang = TRAFX_TXT29;
      break;
  }
  return $mlang;
}


function trafx_admin_genre($mg) {
  switch($mg) {
    case "1":
      $mgenre = TRAFX_TXT30;
      break;
    case "2":
      $mgenre = TRAFX_TXT31;
      break;
    case "3":
      $mgenre = TRAFX_TXT32;
      break;
    case "4":
      $mgenre = TRAFX_TXT33;
      break;
    case "5":
      $mgenre = TRAFX_TXT34;
      break;
    case "6":
      $mgenre = TRAFX_TXT35;
      break;
    default:
      $mgenre = TRAFX_TXT29;
      break;
  }
  return $mgenre;
}
?>
