<?php
//
// Catch all traffic
//
function trafx_catchall_traffic($mid) {
  global $wpdb;
  $sql = $wpdb->get_results("SELECT `kw` FROM ".$wpdb->prefix . "trafx_kw WHERE `id` = '". $mid."' LIMIT 1");
  $mid1 = 0;
  foreach ($sql as $res) {
    $mkw1 = strtolower(urldecode($res->kw));
  }

  $sql = $wpdb->get_results("SELECT `exp`,`pn` FROM ".$wpdb->prefix . "trafx_catchall");
  foreach ($sql as $res) {
    $mkw2 = strtolower(urldecode($res->exp));
    $mpn = $res->pn;
    $ok = 1;
    $mt = explode(" ",$mkw2);
    foreach($mt as $mu) {
      if(!strstr($mkw1,$mu))
        $ok = 0;
    }
    if($ok) {
      $sql2 = "INSERT INTO ".$wpdb->prefix . "trafx_kwsites ( `id1` , `id2`) VALUES ('".$mpn."', '".$mid."')";
      $wpdb->query($sql2);
      return $mpn;
    }
  }
  return 0;
}

//
// Return partner according to keyword
//

function trafx_google_link($mid) {
  global $wpdb;
  $sql = $wpdb->get_results("SELECT `id1` FROM ".$wpdb->prefix . "trafx_kwsites WHERE `id2` = '". $mid."' LIMIT 1");
  $mid1 = 0;
  foreach ($sql as $res) {
    $mid1 = $res->id1;
  }
  return $mid1;
}

//
// Google Traffic
// Return 0 or KW id
//
function trafx_google_traffic($mref) {
  if(!get_option('trafx_option_goog'))
    return 0;
  $q=strstr($mref,".google.");
  if(strlen($q)) {
    $tab=array();
    $q=strstr($mref,"&q=");
    if(strlen($q))
      $tab=split("&q=",$mref);
    else {
      $q=strstr($mref,"?q=");
      if(strlen($q))
        $tab=split("\?q=",$mref);
    }

    if(strlen($tab[1])) {
      $tab=split("&",$tab[1]);
      if(strlen($tab[0])) {
        $t = $tab[0]."\n";
        global $wpdb;
        $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "trafx_kw WHERE  `kw` = '".$tab[0]."'");
        if(!$mc) {
          $sql = "INSERT INTO ".$wpdb->prefix . "trafx_kw ( `kw`,`pr`) VALUES ('".$tab[0]."','1')";
          $wpdb->query($sql);
        }
        else {
          $sql = $wpdb->get_results("SELECT `pr` FROM ".$wpdb->prefix . "trafx_kw WHERE `kw` = '". $tab[0]."'");
          foreach ($sql as $res) {
            $mpr = $res->pr;
          }
          if($mpr > 0)
            $mpr++;
          else
            $mpr = 1;
          $sql = "UPDATE ".$wpdb->prefix . "trafx_kw SET `pr` = '".$mpr."' WHERE `kw` = '".$tab[0]."'";
          $wpdb->query($sql);
        }
        $mid = $wpdb->get_var("SELECT id FROM ".$wpdb->prefix . "trafx_kw WHERE  `kw` = '".$tab[0]."'");
        if($mid)
          return $mid;
      }
    }
  }
  return 0;
}

//
// Standard incoming referer traffic
//

function trafx_standard_traffic($mref) {
  $rf = parse_url($mref);
  $murl = "http://".$rf['host'];
  global $wpdb;
  $mid = $wpdb->get_var("SELECT id FROM ".$wpdb->prefix . "trafx_sites WHERE url = '".$murl."' and
 `ok` = '1'");
  if($mid > 0) {
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "trafx_traffic WHERE  `id` = '".$mid."'");
    if(!$mc) {
      $sql = "INSERT INTO ".$wpdb->prefix . "trafx_traffic ( `id`,`ok`) VALUES ('".$mid."','1')";
      $wpdb->query($sql);
    }
    $sql = $wpdb->get_results("SELECT `in`,`io` FROM ".$wpdb->prefix . "trafx_traffic WHERE `id` ='".$mid."'");
    foreach ($sql as $res) {
      $min = $res->in;
      $mio = $res->io;
    }
    if($min > 0)
      $min++;
    else
      $min = 1;
    $mio++;
    $sql = "UPDATE ".$wpdb->prefix . "trafx_traffic SET `in` = '".$min."', `io` = '".$mio."' WHERE `id` = '".$mid."'";
    $wpdb->query($sql);
  }
}

//
// Random outcoming traffic
//

function trafx_random_out() {
  global $wpdb;
  $n = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . 'trafx_sites WHERE ok = "1"');
  if(!$n)
    return -1;
  $i1 = mt_rand(1, $n);
  $i2 = 1;
  $sql = $wpdb->get_results("SELECT `id` FROM ".$wpdb->prefix . 'trafx_sites WHERE ok = "1"');
  foreach ($sql as $res) {
    if($i1 == $i2)
      $mid = $res->id;
    $i2++;
  }
  return $mid;
}

//
// Mixed outcoming traffic
//

function trafx_mixed_out() {
  $i = mt_rand(1, 2);
  if($i == 1)
    return trafx_clever_out();
  else
    return trafx_random_out();
}
//
// Clever outcoming traffic
//

function trafx_clever_out() {
  global $wpdb;
  $mid = 0;
  $sql = $wpdb->get_results("SELECT `id` FROM ".$wpdb->prefix . 'trafx_traffic WHERE ok = "1" ORDER BY `io` DESC LIMIT 1');
  foreach ($sql as $res) {
    $mid = $res->id;
  }
  if($mid > 0)
    return $mid;
  return -1;
}

//
// The way we will handle outcoming traffic
//

function trafx_handle_out() {

  switch(get_option('trafx_option_out')) {
    case "1":
      return trafx_random_out();
      break;
    case "2":
      return trafx_mixed_out();
      break;
    default:
      return trafx_clever_out();
      break;
  }
}

//
// Incoming traffic switch
//
function trafx_incoming_main() {
  global $trafx_hr;
  if(!$trafx_hr) {
    $trafx_hr++;
    $mref=$_SERVER["HTTP_REFERER"];
    if(!strlen($mref)) // Not referer traffic
      $r = 0;
    else {
      $mid = trafx_google_traffic($mref);
      if($mid)
        $r = 1; // Google traffic
      else {
        trafx_standard_traffic($mref);
        $r = 2; // Referer traffic
      }
    }
    switch($r) {
      case 0: // Direct URL
      case 2: // Referer traffic
        $r = trafx_handle_out();
        break;
      case 1: // Google traffic
        $r = trafx_google_link($mid);
        if(!$r) {
          $r = trafx_catchall_traffic($mid);
          if(!$r) 
            $r = trafx_handle_out();
          else
            $r = $r.".".$mid;
        }
        else 
          $r = $r.".".$mid;
        break;
      default:
        $r = -1;
        break;
    }
    return $r;
  }
  return -1;
}

//
// Handle outcoming traffic
//

function trafx_outurl($mgolink) {

//
// Tip-1
//
  $mc = $_SERVER['DOCUMENT_ROOT'].'/wp-content/plugins/trafx/conf.php';

  include($mc);

  $mip = trafx_decodelinkip(substr($mgolink,0,12));
  $mts =  trafx_decodelinkgo(substr($mgolink,12,10));
  $mid =  sprintf("%d",trafx_decodelinkgo(substr($mgolink,22,8)));
  $mkw = sprintf("%d",trafx_decodelinkgo( substr($mgolink,30,8)));


  $cx = mysql_connect($mhost,$muser,$mpass) || die(TRAFX_TXT1 . mysql_errno());
  mysql_select_db($mdb) || die(TRAFX_TXT2 . mysql_errno());
  $sql = "SELECT COUNT(*) FROM ".$mprefx . "trafx_sites WHERE id = '".$mid."' AND ok = '1'";
  $res = mysql_query($sql);
  if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
  $sqlfetch = mysql_fetch_array($res);
  $n = $sqlfetch['COUNT(*)'];
  if(!$n)
    die(TRAFX_TXT4);

  $sql = "SELECT COUNT(*) FROM ".$mprefx . "trafx_traffic WHERE  `id` = '".$mid."'";
  $res = mysql_query($sql);
  if ( $res == false ) { die( TRAFX_TXT3.$sql ); }
  $sqlfetch = mysql_fetch_array($res);
  $n = $sqlfetch['COUNT(*)'];
  if(!$n) {
    $sql = "INSERT INTO ".$mprefx . "trafx_traffic ( `id`,`ok`) VALUES ('".$mid."','1')";
    $res = mysql_query($sql);
    if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
  }

// Does IP match (else bot search)
  $mp = getenv("REMOTE_ADDR");
  if(!preg_match("/$mp/",$mip)) {
    $sql = "SELECT bot FROM ".$mprefx . "trafx_traffic WHERE  `id` = '".$mid."'";
    $res = mysql_query($sql);
    if ( $res == false ) { die( TRAFX_TXT3.$sql ); }
    $sqlfetch = mysql_fetch_array($res);
    $mbot = $sqlfetch['bot'];
    $mbot++;
    $sql = "UPDATE ".$mprefx . "trafx_traffic SET `bot` = '".$mbot."' WHERE `id` = '".$mid."'";
    $res = mysql_query($sql);
    if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
    die(TRAFX_TXT104);
  }

// Is timestamp still alive
  $sql = "SELECT option_value FROM ".$mprefx . "options WHERE  `option_name` = 'trafx_option_tsttl'";
  $res = mysql_query($sql);
  if ( $res == false ) { die( TRAFX_TXT3.$sql ); }
  $sqlfetch = mysql_fetch_array($res);
  $mttl = $sqlfetch['option_value'];
  $ts = mktime()-intval($mts);
  if($ts > $mttl)
    die(TRAFX_TXT105);

// Keyword
  if(intval($mkw) > 0) {
    $sql = "SELECT COUNT(*) FROM ".$mprefx  . "trafx_kwsites WHERE  `id1` = '".$mid."' AND `id2` ='".$mkw."'";
    $res = mysql_query($sql);
    if ( $res == false ) { die( TRAFX_TXT3.$sql ); }
    $sqlfetch = mysql_fetch_array($res);
    $mc = $sqlfetch['COUNT(*)'];
    if(!$mc) {
      $sql = "INSERT INTO ".$mprefx  . "trafx_kwsites ( `id1`,`id2`,`out`) VALUES ('".$mid."','".$mkw."','0')";
      $res = mysql_query($sql);
      if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
    }
    $sql = "SELECT `out` FROM ".$mprefx . "trafx_kwsites WHERE `id1` = '".$mid."' AND `id2` = '".$mkw."'";
    $res = mysql_query($sql);
    if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
    $sqlfetch = mysql_fetch_array($res);
    $mout = $sqlfetch['out'];
    if($mout > 0)
      $mout++;
    else
      $mout = 1;
    $sql = "UPDATE ".$mprefx . "trafx_kwsites SET `out` = '".$mout."' WHERE `id1` = '".$mid."' AND `id2` = '".$mkw."'";
    $res = mysql_query($sql);
    if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
  }

// Partner
  $sql = "SELECT `out`,`io` FROM ".$mprefx . "trafx_traffic WHERE `id` = '".$mid."'";
  $res = mysql_query($sql);
  if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
  $sqlfetch = mysql_fetch_array($res);
  $mout = $sqlfetch['out'];
  $mio = $sqlfetch['io'];
  if($mout > 0)
    $mout++;
  else
    $mout = 1;
  $mio--;
  $sql = "UPDATE ".$mprefx . "trafx_traffic SET `out` = '".$mout."', `io` = '".$mio."' WHERE `id` = '".$mid."'";
  $res = mysql_query($sql);
  if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
  $sql = "SELECT url FROM ".$mprefx . "trafx_sites WHERE id = '".$mid."'";
  $res = mysql_query($sql);
  if ( $res == false ) { die(TRAFX_TXT3.$sql ); }
  $sqlfetch = mysql_fetch_array($res);
  $url = $sqlfetch['url'];
  header('Status: 301 Moved Permanently', false, 301);
  header("Location: $url");
  die;
}
?>
