<?php
/*
Plugin Name: TrafX
Plugin URI: http://www.pagasa.net/trafx-plugin/
Description: Echanger du trafic facilement avec d'autres blogs.
Author: Thibaut Maquet
Version: 1.7
Author URI: http://www.pagasa.net/
*/

//
// Local
//

include("fr.php");
include("traffic.php");
include("code.php");
include("market.php");
include("intercom.php");
include("keywords.php");
include("partners.php");
include("prefs.php");
include("misc.php");
include("com.php");



function trafx_filter($content){
  global $trafx_yy;

  $mid = trafx_incoming_main();
  if($mid == -1)
    return $content;
  $q=strstr($mid,".");
  if(strlen($q)) {
    $t = split("\.",$mid);
    $mid = intval($t[0]);
    $mkw = $t[1];
  }
  else
    $mkw = 0;
  global $wpdb;
  $sql = $wpdb->get_results("SELECT `url`, `desc` FROM ".$wpdb->prefix . "trafx_sites WHERE id = '".$mid."' LIMIT 1");
  foreach ($sql as $res) {
    $murl = $res->url;
    $mdesc = $res->desc;
  }
  $mcontent = $content;

  $mok = 0;
  if(is_single())
    $mok = 1;
  else {
    $o = get_option('trafx_option_aff');
    if($o == '2' || !$trafx_yy) 
      $mok = 1; 
  }

  if($mok) {
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "trafx_traffic WHERE  `id` = '".$mid."'");
    if(!$mc) {
      $sql = "INSERT INTO ".$wpdb->prefix . "trafx_traffic ( `id`,`ok`) VALUES ('".$mid."','1')";
      $wpdb->query($sql);
    }
    if($mkw) {
      $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "trafx_kwsites WHERE  `id1` = '".$mid."' AND `id2` = '".$mkw."'");
      if(!$mc) {
        $sql = "INSERT INTO ".$wpdb->prefix . "trafx_kwsites ( `id1`,`id2`,`dis`) VALUES ('".$mid."','".$mkw."','0')";
        $wpdb->query($sql);
      }
    }

    $sql = $wpdb->get_results("SELECT `dis` FROM ".$wpdb->prefix . "trafx_traffic WHERE `id` = '".$mid."'");
    foreach ($sql as $res) {
      $mdis = $res->dis;
    }
    if($mdis > 0)
      $mdis++;
    else
      $mdis = 1;
    $sql = "UPDATE ".$wpdb->prefix . "trafx_traffic SET `dis` = '".$mdis."' WHERE `id` = '".$mid."'";
    $wpdb->query($sql);

    if($mkw) {
      $sql = $wpdb->get_results("SELECT `dis` FROM ".$wpdb->prefix . "trafx_kwsites WHERE `id1` = '".$mid."' AND `id2` = '".$mkw."'");
      foreach ($sql as $res) {
        $mdis = $res->dis;
      }
      if($mdis > 0)
        $mdis++;
      else
        $mdis = 1;
      $sql = "UPDATE ".$wpdb->prefix . "trafx_kwsites SET `dis` = '".$mdis."' WHERE `id1` = '".$mid."' AND `id2` = '".$mkw."'";
      $wpdb->query($sql);
    }

    $mout = "";
    $mout = $mout."<center>";
    $mout = $mout. '<font size="'.get_option('trafx_option_fnt').'">';
    $mout = $mout. '<a href="'.get_option('siteurl').'/trafx.php?go=';
     
    $mout .= trafx_codelinkip(getenv("REMOTE_ADDR"));
    $mout .= trafx_codelinkgo(mktime());
    $mout .= trafx_codelinkgo(sprintf("%08d",$mid));
    $mout .= trafx_codelinkgo(sprintf("%08d",$mkw));

    $mout .= '"';


    if(get_option('trafx_option_fol')=='1') 
      $mout = $mout. " rel='nofollow'";
    if(get_option('trafx_option_trg')=='1') 
      $mout = $mout. " target='_blank'";
    $mout = $mout.">";
    if(get_option('trafx_option_clg')=='1') 
      $mout = $mout.'<blink>'.$mdesc."</blink>";
    else
      $mout = $mout.$mdesc;
    $mout = $mout."</a></font></center>\n";
   
    $mtag = "<!-- trafx_link -->";
    if(preg_match("/$mtag/",$mcontent)) 
      $mcontent = preg_replace("/$mtag/","$mout",$mcontent);
    else
      $mcontent .= $mout;   
  }
  $trafx_yy++;
  return $mcontent;  
}




//
// Admin menu
//

function trafx_admin_menu($mout) {

  $a = "";

  $a .= "<h2>TrafX</h2>";

  $a .= trafx_admin_status($mout);

  $a .= trafx_admin_intercom();

  $a .= trafx_admin_traffic();

  $a .= trafx_admin_partners();

  $a .= trafx_admin_add_partner();

  $a .= trafx_admin_prefs();

  $a .= trafx_admin_display_market();

  $a .= trafx_admin_misc();

  echo $a;
}

//
// Admin routing
//

function trafx_display_settings() {
  global $wpdb;

  $mop = (isset($_GET['op'])) ? $_GET['op'] : "0";
  $mid = (isset($_GET['id'])) ? $_GET['id'] : "0";
  $mod = (isset($_GET['mo'])) ? $_GET['mo'] : "0";

  switch($mop) {
    case "eff":
      trafx_admin_delete($mid);
      break;
    case "rst":
      trafx_admin_reset($mid);
      break;
    case "pau":
      trafx_admin_pause($mid);
      break;
    case "rpr":
      trafx_admin_resume($mid);
      break;
    case "add":
      trafx_admin_add();
      break;
    case "pref":
      trafx_admin_pref();
      break;
    case "mod":
      trafx_admin_modify($mid);
      break;
    case "upd":
      trafx_admin_update($mid);
      break;
    case "mkadd":
      trafx_admin_mkadd();
      break;
    case "mkrem":
      trafx_admin_mkrem($mid);
      break;
    case "market":
      trafx_admin_market();
      break;
    case "itrem":
      trafx_admin_rem_intercom($mid);
      break;
    case "keywords":
      trafx_admin_keywords($mid,$mod);
      break;
    case "kwadd":
      trafx_admin_add_keywords($mid);
      break;
    case "kwstat":
      trafx_admin_stat_keywords($mid,$mod);
      break;
    case "catchadd":
      trafx_catch_add($mid);
      break;
    case "catchrem":
      trafx_catch_rem($mid);
      break;
    default:
      trafx_admin_menu("");
      break;
  }
}

function trafx_admin_settings() {
  if (function_exists('add_options_page')){
    add_options_page("TrafX", "TrafX", 'manage_options', 'trafx-pid', "trafx_display_settings");
  }
}


//
// Plugin initialization
//
function trafx_init() {
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

  global $wpdb;

  $tname = $wpdb->prefix . "trafx_sites";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL auto_increment,
    `name` varchar(120) NOT NULL default '',
    `url` varchar(120) NOT NULL default '',
    `desc` varchar(120) NOT NULL default '',
    `email` varchar(120) NOT NULL default '',
    `ok` char(1) NOT NULL default '',
    PRIMARY KEY  (`id`),
    KEY `url` (`url`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "trafx_intercom";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL default '0',
    `ok` char(1) NOT NULL default '',
    `txt` text NOT NULL
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "trafx_traffic";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") == $tname) {
    $sql = "DROP TABLE `". $tname . "`";
    $wpdb->query($sql);
  }

  $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL default '0',
    `in` int(11) NOT NULL default '0',
    `io` int(11) NOT NULL default '0',
    `out` int(11) NOT NULL default '0',
    `dis` int(11) NOT NULL default '0',
    `bot` int(11) NOT NULL default '0',
    `ok` char(1) NOT NULL default '',
    KEY `id` (`id`)
    );";
  dbDelta($sql);

  $tname = $wpdb->prefix . "trafx_kwsites";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") == $tname) {
    $sql = "DROP TABLE `". $tname . "`";
    $wpdb->query($sql);
  }

  $sql = "CREATE TABLE " . $tname . " (
    `id1` int(11) NOT NULL default '0',
    `id2` int(11) NOT NULL default '0',
    `dis` int(11) NOT NULL default '0',
    `out` int(11) NOT NULL default '0',
    KEY `id1` (`id1`),
    KEY `id2` (`id2`)
  );";
  dbDelta($sql);


  $tname = $wpdb->prefix . "trafx_kw";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") == $tname) {
    $sql = "DROP TABLE `". $tname . "`";
    $wpdb->query($sql);
  }
  $sql = "CREATE TABLE " . $tname . " (
    `kw` varchar(100) NOT NULL default '',
    `pr` int(11) NOT NULL default '0',
    `id` int(11) NOT NULL auto_increment,
    PRIMARY KEY  (`id`),
    KEY `kw` (`kw`)
    );";
  dbDelta($sql);

  @unlink(ABSPATH ."wp-content/plugins/trafx/market"); 

  $tname = $wpdb->prefix . "trafx_market";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") == $tname) {
    $sql = "DROP TABLE `". $tname . "`";
    $wpdb->query($sql);
  }
  $sql = "CREATE TABLE " . $tname . " (
    `site` varchar(100) NOT NULL default '',
    `url` varchar(100) NOT NULL default '',
    `genre` varchar(2) NOT NULL default '',
    `lang` varchar(2) NOT NULL default '',
    `nom` varchar(50) NOT NULL default '',
    `id` int(11) NOT NULL,
    KEY `site` (`site`)
    );";
  dbDelta($sql);

  $tname = $wpdb->prefix . "trafx_catchall";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") == $tname) {
    $sql = "DROP TABLE `". $tname . "`";
    $wpdb->query($sql);
  }

  $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL auto_increment,
    `exp` varchar(150) NOT NULL default '',
    `pn` int(11) NOT NULL default '0',
    PRIMARY KEY  (`id`)
    );";
  dbDelta($sql);


  if(!get_option('trafx_option_out'))
    add_option('trafx_option_out','2','','yes');
  if(!get_option('trafx_option_fol'))
    add_option('trafx_option_fol','1','','yes');
  if(!get_option('trafx_option_blk'))
    add_option('trafx_option_blk','1','','yes');
  if(!get_option('trafx_option_clg'))
    add_option('trafx_option_clg','1','','yes');
  if(!get_option('trafx_option_fnt'))
    add_option('trafx_option_fnt','+2','','yes');
  if(!get_option('trafx_option_aff'))
    add_option('trafx_option_aff','1','','yes');
  if(!get_option('trafx_option_goog'))
    add_option('trafx_option_goog','','','yes');
  if(!get_option('trafx_option_inc'))
    add_option('trafx_option_inc','1','','yes');
 if(!get_option('trafx_option_tsttl'))
    add_option('trafx_option_tsttl','600','','yes');
  
  $fd = fopen(ABSPATH ."wp-content/plugins/trafx/conf.php","w");
  $a = "<?php\n".'$mdb="'.DB_NAME.'";'."\n".'$muser="'.DB_USER.'";'."\n".'$mpass="'.DB_PASSWORD.'";'."\n".'$mhost="'.DB_HOST.'";'."\n".'$mprefx="'.$wpdb->prefix.'";'."\n"."?>";
  fwrite($fd,$a);
  fclose($fd);

  if (!wp_next_scheduled('trafx_cron_hook'))
    wp_schedule_event( time(), 'daily', 'trafx_cron_hook' );

}

//
// Plugin deinit
//

function trafx_deinit() {
  $mid = get_option('trafx_market');
  if(strlen($mid)) {
    $mc = "02;".$mid;
    $min = "cargo=".urlencode($mc);
    $mrep = trafx_send_socket("trafx-mk.php?op=cargo",$min,TRAFX_TXT92,TRAFX_TXT93);
    delete_option('trafx_market');
  }
  wp_clear_scheduled_hook('trafx_cron_hook');
}


//
// main() sweet main()
//

$mgo = (isset($_GET['go'])) ? $_GET['go'] : "0";
if($mgo) {
  trafx_outurl($mgo);
  die;
}

register_activation_hook(__FILE__,'trafx_init');
register_deactivation_hook(__FILE__,'trafx_deinit');
 
add_filter('the_content', 'trafx_filter', 25);
add_filter('the_excerpt', 'trafx_filter', 25);

add_action('admin_menu', 'trafx_admin_settings');
add_action( 'trafx_cron_hook', 'trafx_fetch_data');
?>
